<template>
  <v-container>
    <div>
      <h1>L'id : {{id}}</h1>
      <h1>Le Nom : {{lastname}}</h1>
      <h1>Le Prénom : {{firstname}}</h1>
      <h1>Le Mail : {{email}}</h1>
      <h1>Date de création : {{date_created}}</h1>
      <v-btn
          @click="deleteClient()"
          color="error"
      >
        Supprimer le client</v-btn>
      <v-dialog
          v-model="displayDialog"
          max-width="600px"
          :retain-focus="false"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn
              color="warning"
              dark
              v-bind="attrs"
              v-on="on"
          >
            Modifier le Client
          </v-btn>
        </template>
        <v-card>
          <v-form>
            <v-card-title>
              <span class="headline">Client</span>
            </v-card-title>
            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.lastname"
                        label="Nom*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.firstname"
                        label="Prénom*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.email"
                        label="Email*"
                        type="email"
                        required
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-container>
              <small>*L'étoile indique les champs requis</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="displayDialog = false"
              >
                Fermer la fenêtre
              </v-btn>
              <v-btn
                  @click="displayDialog = false; updateClient();"
                  color="blue darken-1"
              >
                Modifier
              </v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </v-dialog>
    </div>
  </v-container>
</template>

<script>

export default {
name: "ClientComponent",
  props: {
    id: Number,
    lastname: String,
    firstname: String,
    email: String,
    date_created: {
      type: Date,
      default: new Date()
    }
  },
  data() {
    return {
      displayDialog: false,
      dialog: {
        lastname: '',
        firstname: '',
        email: ''
      }
    }
  },
  mounted() {
    this.dialog.lastname = this.lastname
    this.dialog.firstname = this.firstname
    this.dialog.email = this.email
  },
  methods: {
    updateClient() {
      this.$axios.patch(`/client/${this.id}`, {firstname: this.dialog.firstname, lastname: this.dialog.lastname, email: this.dialog.email})
          .then(() => {
            this.$emit("updated")
          }).catch((erreur) => {
        console.log(erreur)
      })
    },

    deleteClient() {
      this.$axios.delete(`/client/${this.id}`)
          .then(response => {
            this.$emit("updated")
          }).catch((erreur) => {
        console.log(erreur)
      })
    }
  },
}
</script>

<style scoped>

</style>